#************************************************************************
#* MODULE INFORMATION*
#*********************
#*     FILE     NAME:       aps.mak
#*     SYSTEM   NAME:       BEHOLDER
#*     ORIGINAL AUTHOR(S):  Jan van Oorschot
#*     VERSION  NUMBER:     1.00
#*     CREATION DATE:       16-10-90
#*
#* DESCRIPTION:
#************************************************************************
#* CHANGES INFORMATION **
#************************
#* REVISION:    $Revision:   1.1  $                     
#* WORKFILE:    $Workfile:   aps.mak  $
#* LOGINFO:     $Log:   I:/ETSTJAN/CPROG/BEHOLDER/APS/VCS/APS.MAV  $
#  
#     Rev 1.1   01 Feb 1991 16:39:04   etstjan
#  No explicit note
#  
#     Rev 1.0   01 Feb 1991 16:37:06   etstjan
#  tNo explicit note
#  
#     Rev 1.0   31 Jan 1991 16:48:12   etstjan
#  tNo explicit note
#************************************************************************
HOMEDIR = ..\
NEWTREE = .^\
MODEL=L
MODE=r
CFLAGS=/W4 /Ox /A$(MODEL) /L$(MODE) /I$(HOMEDIR)\INCLUDE /I..\INCLUDE /Fmsnmp.map
LFLAGS=/MAP /STACK:8000  
MFLAGS=HOMEDIR="$(HOMEDIR)" CFLAGS="$(CFLAGS)" LFLAGS="$(LFLAGS)" MODE=$(MODE) MODEL=$(MODEL)
ID=$(HOMEDIR)\INCLUDE
LD=$(HOMEDIR)\LIB
LIB=$(LD);$(LIB)
ED=$(HOMEDIR)\EXE
PUTNOTE="No explicit note"

SYSTEM=aps

ALIBS = 

BLIBS= 

PARTS= FERGIE GOBBLER

LIBS = $(ALIBS) $(BLIBS)

CS=
AS=
CTS=
HS=
MAKS=$(SYSTEM).mak
DOCS=
SRCS=$(MAKS) $(CS) $(AS) $(HS) $(DOCS) $(CTS) 
OBJS=
TOBJS=
EXES=
TEXES= 
EXPORTS=
#************************************************************************
#*  Supported make commands:
#*
#*      all     -->     do a full make of this system part
#*      compile -->     do a compile of all c-files
#*      lib     -->     collect all obj's in a lib
#*      exe     -->     make exe's
#*      clean   -->     throw out all garbage
#*      collect -->     copy all .lib and .h files to global directories
#*      put     -->     do a PVCS put of the sources 
#*      get     -->     do a PVCS get of the sources
#*      getlock -->     do a PVCS get of the sources and put a lock on them
#*      makedir -->     Make all subdirectories in the given
#*                      tree $(NEWTREE)
#************************************************************************
all clean collect get put getlock makedir:  
    @$(MAKE) /NOLOGO /F $(SYSTEM).mak MOPT=$* $(PARTS) 
    @$(MAKE) /NOLOGO /F $(SYSTEM).mak $*.own 

$(PARTS) :
    @cd $*
    @echo (1) $* Build
    @$(MAKE) /NOLOGO /F $*.mak $(MOPT)
    @echo (1) $* Ready
    @cd ..
    

all.own: 
    @echo Start $(SYSTEM) all

clean.own:
    @-del *.obj 2>nul
    @-del *.lib 2>nul
    @-del *.bak 2>nul
    @-del *.err 2>nul
    @-del *.exe 2>nul


collect.own: $(EXPORTS)


put.own:    $(SRCS)
    !@-PUT -l -n -m$(PUTNOTE) $**

getlock.own:    $(SRCS)
    !-GET -l $**


get.own:    $(SRCS)
    !-GET  $**

makedir.own:
    mkdir $(NEWTREE)\VCS

#************************************************************************
#*  actual components and relations
#************************************************************************

