/************************************************************************
** MODULE INFORMATION*
**********************
**     FILE     NAME:       BEHOLDER.H
**     SYSTEM   NAME:       BEHOLDER
**     ORIGINAL AUTHOR(S):  Wim van Campen
**     VERSION  NUMBER:     1.0
**     CREATION DATE:       1990/8/1
**
** DESCRIPTION: Global Include file for the Beholder System.
*************************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:    $Revision$
** WORKFILE:    $Workfile$
** LOGINFO:     $Log$
*************************************************************************/
#include      <dp.h>                   /* for DP... definitions             */
#include      <dnpap.h>
#include      <bufm.h>                 /* for ipbufget                      */
#include      <socket.h>               /* socket library functions          */
#include      <futil.h>                /* StrUpper                          */

/* global variables */
extern DPAPPS           DpaIP;              /* IP Stack Application         */
extern DPAPPS           DpaIPStat;          /* IP Status descriptor         */
extern DPAPPS           DpaPing;            /* Ping application descriptor  */
extern DPAPPS           DpaEcho;            /* Echo daemon descriptor       */
extern DPAPPS           DpaTftp;            /* Tftp server descriptor       */
extern DPAPPS           DpaLen;
extern DPAPPS           DpaType;
extern DPAPPS           DpaSrc;
extern DPAPPS           DpaStat;
extern DPAPPS           DpaSec;
extern DPAPPS           DpaSec2;
extern DPAPPS           DpaMin;
extern DPAPPS           DpaCapt;
extern DPAPPS           DpaPkt;
extern DPAPPS           DpaTraf;
extern DPAPPS           DpaSnmp;
extern DPAPPS           DpaLoad;
extern DPAPPS           DpaControl;
extern DPAPPS           DpaMat;
extern DPAPPS           DpaDog;
extern DPAPPS           DpaDisp;
extern DPAPPS           DpaPort;
extern DPAPPS           DpaPktCapt;
extern DPAPPS           DpaNNP;
extern DPAPPS           DpaVision;
extern DPAPPS           DpaFileView;

extern DPFILT           DpfPkt;

extern char             DpaCaptDumpFile[];
                                            /* obtained by time()           */
extern char* BeholderDescription; 
extern char* BeholderDate; 

