/*************************************************************************
** MODULE INFORMATION*
**********************
**     FILE     NAME:       CLOCK.H
**     SYSTEM   NAME:       CLOCK
**     ORIGINAL AUTHOR(S):  Alfred Kayser
**     VERSION  NUMBER:     1.1
**     CREATION DATE:       90/01/08
**                                                                  
** DESCRIPTION: Microsecond resolution clock routine.
**              Written by David L. Fox.
**              Implements in C the timer chip tweaking described by
**              Byron Sheppard, _Byte_, Jan 1987, p 157-164.
**              Ported to MSC by Alfred Kayser. Recalculated the
**              Timer constants which where slightly incorrect.
**              Also some optimalizations are done.
**              Rewritten 90/05/01 in MASM by Alfred Kayser.
**              Rel. error is 0.01%. Granularity is 0.838574 microsecs.
***********************************************************************
** CHANGES INFORMATION **
*************************
** REVISION:    $Revision:   1.0  $
** CHANGER:     $Author:   etstjan  $
** WORKFILE:    $Workfile:   CLOCK.H  $
** LOGFILE:     $Logfile:   I:/ETSTJAN/C600/BEHOLDER/NPD/DP/VCS/CLOCK.H_V  $
** LOGINFO:     $Log:   I:/ETSTJAN/C600/BEHOLDER/NPD/DP/VCS/CLOCK.H_V  $
**              
**                 Rev 1.0   26 Oct 1990 12:28:24   etstjan
**              Initial revision.
**********************************************************************/

unsigned long clock_ms(void);     /* defined in clocka.asm */
unsigned long clock_us(void);     /* defined in clocka.asm */
void          clock_init(void);   /* defined in clocka.asm */
void          clock_exit(void);   /* defined in clocka.asm */

