/*****************************************************************
** MODULE INFORMATION*
**********************
**      FILE    NAME:       PWDCL.H
**      SYSTEM  NAME:       POWER
**      VERSION NUMBER      3.00
**
** DESCRIPTION: function declarations for
**              Programmer Oriented Window Environment Routines.
**              (NoC) July 1989 - Ling Thio Software Productions.
******************************************************************
** ADMINISTRATIVE INFORMATION*
******************************
**      ORIGINAL AUTHOR:    Ling Thio
**      CREATION DATE:      89/07/10
**      CHANGES:            none
*****************************************************************/

/* PWGINIT.C */
extern  void pwg_strncpy(char *dest, char *src, int n);
extern  void pwg_CursorOff(void);
extern  int  pwg_ExitFunc(void);

/* PWxUTI.C */
extern  int  pws_shell(void);
extern  void pws_MouInit(void);
extern  void pws_MouReset(void);
extern  void pws_MouScan(PWKEY *pKey, PWKEY *pw_mou_key);
extern  PWKEY pws_getkey(void);

extern  void pws_mon(void);
extern  void pws_GetCursor(int *pRow, int *pCol);
extern  void pws_cursor(int row, int col);

/* PWBINIT */
extern  void pwb_init1(PWCELL far *oldbuf);
extern  int pwb_init2(void);
extern  void pwb_exit(void );
extern  int pwb_open(PWWIN *win,int level);
extern  void pwb_shade(PWWIN *win);
extern  void pwb_shaderestore(PWWIN *win);
extern  void pwb_close(PWWIN *win);
extern  void pwb_pop(PWWIN *win);
extern  void pwb_hide(PWWIN *win);
extern  void pwb_show(PWWIN *win);
extern  void pwb_move(PWWIN *win);
extern  int pwb_top(PWWIN *win);
extern  PWWIN *pwb_activewin(void );
extern  void pwb_initwin(PWWIN *win);
extern  void pwb_initoffset(int crow,int ccol);
extern  void pwb_refreshblock(int activelevel, int srow, int scol, int nrow, int ncol);
extern  void pwb_refreshwin(PWWIN *win);
extern  void pwb_scroll_up(PWWIN *win,int srow,int scol,int nrow,int ncol,int scrolls);
extern  void pwb_scroll_down(PWWIN *win,int srow,int scol,int nrow,int ncol,int scrolls);
extern  void pwb_scroll_left(PWWIN *win,int srow,int scol,int nrow,int ncol,int scrolls);
extern  void pwb_scroll_right(PWWIN *win,int srow,int scol,int nrow,int ncol,int scrolls);
extern  void pwb_shellinit(void);
extern  void pwb_shellend(void);
/* PWGBLOC */
/* PWGCOPY */
/* PWGFILE */
/* PWGGETK */
extern  int pwg_keyinit(void);
extern  int pwl_kbhit(void );
extern  unsigned int pwl_getkey(void );
extern  void pwl_kbwait(unsigned int (*wait_function)(void ));
extern  void pwl_mou_define(int mou_event,unsigned int key);
extern  void pwl_SetMouDef(PWCELL *MouDef);
extern  PWCELL *pwl_GetMouDef(void);
/* PWGHBAR */
/* PWGHSCR */
/* PWGINIT */
extern  unsigned int pwg_message(char *header,char *message,char *keyleft,char *keyright);
extern  void far *pwg_malloc(unsigned int size);
extern  void pwg_free(void far *source);
/* PWGINP */
/* PWGKEY */
extern  void pwg_keyinfo(char *left,char *right);
/* PWGCLS */
/* PWGMENU */
extern  void pwl_cls(PWWIN *win,int srow,int scol,int nrow,int ncol);
/* PWGOPEN */
extern  void pwg_initcoord(PWWIN *win);
extern  void pwg_initwin(PWWIN *win);
/* PWGPUT */
/* PWGSHAD */
/* PWGVBAR */
/* PWGVSCR
/* PWGWAIT */
/* PWVINIT */
extern  unsigned int pwv_shadecell(unsigned int cell);
extern  unsigned char pwv_attrib(int wintype,int texttype);
/* PWVBLOC */

#ifdef  __TSC__
#pragma save
#pragma call(reg_saved => (ds,si,di), \
             c_conv    => on, \
             reg_param => ())
#endif
/* PWVASM.ASM */
extern  void   pwv_cursor(PWWIN *win);
extern  void   pwv_putc(PWWIN *win, int c);
extern  void   pwv_putattr(PWWIN *win, int attr);
extern  void   pwv_putcell(PWWIN *win, PWCELL cell);
extern  PWCELL pwv_getcell(PWWIN *win);

extern  void   pwv_rawputcell(unsigned offset, PWCELL cell);
extern  PWCELL pwv_rawgetcell(unsigned offset);

extern  void pwv_save(int srow, int scol, int nrow, int ncol, unsigned int far *buffer, int size);
extern  void pwv_display(int srow, int scol, int nrow, int ncol, PWCELL far *buffer, int bufncol);
extern  void pwv_levelblock(int srow, int scol, int nrow, int ncol, unsigned char far *buffer, int level);
extern  void pwv_moveleft(PWCELL far *dest, int destncol, PWCELL far *src, int srcncol, int nrow, int ncol);
extern  void pwv_moveright(PWCELL far *dest, int destncol, PWCELL far *src, int srcncol, int nrow, int ncol);
extern  void pwv_fillblock(PWCELL far *dest, int destncol, int nrow, int ncol, PWCELL cell);

/* PWxVIO.ASM */
extern int pwv_init(void);
#ifdef  __TSC__
#pragma restore
#endif

