/*****************************************************************
** MODULE INFORMATION*
**********************
**      FILE    NAME:       PWDEF.H
**      SYSTEM  NAME:       POWER
**      VERSION NUMBER      2.00
**
** DESCRIPTION: Include file for structs and defines for
**              Programmer Oriented Window Environment Routines.
**              (NoC) July 1989 - Ling Thio Software Productions.
******************************************************************
** ADMINISTRATIVE INFORMATION*
******************************
**      ORIGINAL AUTHOR:    Ling Thio
**      CREATION DATE:      89/07/10
**      CHANGES:            none
*****************************************************************/

#define MAX_WINS        64                  /* max # of wins open at 1 time */
#define BGCHAR          0                   /* offset in _pwcf_backgr */
#define INPCHAR         1
#define SCRATCH_LEN     (132+1)
#define PW_TYPE_CHAR    '@'
#define PW_HELP_CHAR    '&'

#define STAT_SHADE      0x01
#define STAT_HIDEWIN    0x02
#define STAT_DOSSHELL   0x04
#define STAT_HIDE       0x06
#define STAT_TYPECHAR   0x08

#define MAX_COLS	    80
#define MAX_ROWS	    25
#define MAX_DCOLS	    160
#define LEN_PATH        128

#define PWT_PLAIN       9
#define PWK_HELP        PWK_F1
#define PWK_INFO        PWK_F2
#define PWK_EXIT        PWK_SF3
#define PWK_SHELL       PWK_CF3
#define PWK_MOVE        PWK_SF4
#define PWK_RESTORE     PWK_F6
#define PWK_KEYHELP     PWK_F9
#define PWK_MACRO       PWK_SF10
#define PWK_MACRODEF    PWK_CF10

#define PWCF_TL         0
#define PWCF_TR         1
#define PWCF_BL         2
#define PWCF_BR         3
#define PWCF_H          4
#define PWCF_V          5
#define PWCF_TT         6
#define PWCF_BT         7
#define PWCF_LT         8
#define PWCF_RT         9
#define PWCF_X          10

#define PW_IN_HELP      0x01
#define PW_IN_INFO      0x02
#define PW_IN_KEYHELP   0x04
#define PW_IN_MOVE      0x08
#define PW_IN_INPUT     0x10
#define PW_IN_MACRODEF  0x20
#define PW_IN_MACRONAME 0x40
#define PW_INIT         0x80
#define PW_MOU_DEFAULT  8

#define PWCF_CGACOLOR   0                   /* CGA/EGA/VGA+color mon */
#define PWCF_CGAMONO    1                   /* CGA/EGA/VGA+mono mon */
#define PWCF_MDAMONO    2                   /* MDA+monchrome monitor */
#define PWCF_MONS       3
#define PWCF_WINS       9
#define PWCF_TTYPES     6
#define BACKGRSIZE      8
#define BORDERSIZE      16
#define ATTRIBSIZE      (PWCF_MONS*PWCF_WINS*PWCF_TTYPES)
#define ENVSIZE         12

#define pwv_attrib(win,text)    pw_attrib(win,text)
