/* [DOC] File ****************************************************
** MODULE INFORMATION*
**********************
**      FILE    NAME:       PWGCOPY.C
**      SYSTEM  NAME:       POWER
**      VERSION NUMBER      3.00
**
** Descr:       Copyright message function for
**              Programmer Oriented Window Environment Routines.
**              (NoC) July 1989 - Ling Thio Software Productions.
******************************************************************
** ADMINISTRATIVE INFORMATION*
******************************
**      ORIGINAL AUTHOR:    Ling Thio
**      CREATION DATE:      89/07/10
**      CHANGES:            none
*****************************************************************/

#include "pwinc.h"                          /* Main include file */

PWKEY pw_copyright(char *progname, char *progver, int price)
{
    unsigned int ret;
    char temp[SCRATCH_LEN];
    PWWIN *crwin;

    sprintf(temp, "%s Copyright", progname);
    crwin = pw_open(PWC_CENTER, PWC_CENTER, 18, 60, temp, PWM_HIDE, PWW_HELP);
    sprintf(temp, "%2d", price);
    pw_puts(crwin, "           This program  is presented to you by:\n\n");
    pw_printf(crwin, "              %s.\n\n", _pw_ltsp);
    pw_block(crwin, 2, 0, 1, 0, PWT_HIGHLIGHT);
    pw_puts(crwin, " It carries  no Copyright  so it may be distributed freely.\n");
    pw_puts(crwin, " If, however, you like using  this product,  the programmer\n");
    pw_puts(crwin, " will appreciate  a contribution of ");
    pw_puts(crwin, temp);
    pw_puts(crwin, " guilders  (or more).\n");
    pw_puts(crwin, " In addition to a clear conscience, you will receive notice\n");
    pw_puts(crwin, " of updates and other usefull programs  by this programmer.\n\n");
    pw_puts(crwin, " Please make GIRO cheque payable to:\n");
    pw_puts(crwin, "     CSE Computer Systems Expertise,     AMRO: 46.55.47.079\n");
    pw_puts(crwin, "     G. Gezellelaan 49, 2624 KX  Delft, Holland.\n");
    pw_puts(crwin, "     Identify with '");
    pw_puts(crwin, progname);
    pw_putc(crwin, ' ');
    pw_puts(crwin, progver);
    pw_puts(crwin, "'.\n\n");
    pw_puts(crwin, " Suggestions  for program improvements  are evenly welcome.\n\n");
    pw_puts(crwin, " Enjoy the use of this product            -           Ling.");
    pw_show(crwin);
    pw_keyinfo(crwin, "F1=Help  F9=Keys  Esc=Exit", NULL);
    ret = pw_getkey();
    pw_close(crwin);
    return(ret);
}



