/* hfile.inc - placed into all .h files to set up for PVCS 
   $Header:   E:/pcdirs/vcs/nkeys.h_v   1.0   15 Jan 1990 19:30:40   bkc  $
   Revision History ----------------------------------------------------
   $Log:   E:/pcdirs/vcs/nkeys.h_v  $
 * 
 *    Rev 1.0   15 Jan 1990 19:30:40   bkc
*/


/*  
*  Definitions of keys returned by n_getchar()
*  (Many kept compatible with Greenleaf functions
*/

#ifndef	NEWKEY
#define F1   0x80
#define F2   0x81
#define F3   0x82
#define F4   0x83
#define F5   0x84
#define F6   0x85
#define F7   0x86
#define F8   0x87
#define F9   0x88
#define F10  0x89
#define F11  0xea
#define F12  0xeb

#define SF1  0x90
#define SF2  0x91
#define SF3  0x92
#define SF4  0x93
#define SF5  0x94
#define SF6  0x95
#define SF7  0x96
#define SF8  0x97
#define SF9  0x98
#define SF10 0x99
#define SF11 0xec
#define SF12 0xed

#define CF1  0xA0
#define CF2  0xA1
#define CF3  0xA2
#define CF4  0xA3
#define CF5  0xA4
#define CF6  0xA5
#define CF7  0xA6
#define CF8  0xA7
#define CF9  0xA8
#define CF10 0xA9
#define CF11 0xef
#define CF12 0xf0

#define ALT1 0xb0
#define ALT2 0xb1
#define ALT3 0xb2
#define ALT4 0xb3
#define ALT5 0xb4
#define ALT6 0xb5
#define ALT7 0xb6
#define ALT8 0xb7
#define ALT9 0xb8
#define ALT0 0xb9

#define AF1  0xE0
#define AF2  0xE1
#define AF3  0xE2
#define AF4  0xE3
#define AF5  0xE4
#define AF6  0xE5
#define AF7  0xE6
#define AF8  0xE7
#define AF9  0xE8
#define AF10 0xE9
#define AF11 0xf1
#define AF12 0xf2

#define HOME		0x8A	/* HOME key	*/
#define CURLF		0x8B	/* <-		*/
#define ENDKEY		0x8C	/* END key	*/
#define CURUP		0x8D	/* up arrow	*/
#define CURDN		0x8E	/* down arrow	*/
#define PGUP		0x9A	/* PgUp		*/
#define CURRT		0x9B	/* ->		*/
#define PGDN		0x9C	/* PgDn		*/
#define INSERT		0x9D	/* Ins		*/
#define DELETE		0x9E	/* Del		*/
#define CTRLHOME	0xAA	/* Ctrl Home	*/
#define CTRLCURLF	0xAB	/* Ctrl <-	*/
#define CTRLEND		0xAC	/* Ctrl End	*/
#define CTRLPRTSC	0xAE	/* Ctrl PrtSc	*/
#define CTRLPGUP	0xBA	/* Ctrl PgUp	*/
#define CTRLCURRT	0xBB	/* Ctrl ->	*/
#define CTRLPGDN	0xBC	/* Ctrl PgDn	*/
#define REVTAB		0x8F	/* Shift Tab	*/
#define ALTMINUS	0xBD	/* Alt -	*/
#define ALTEQUAL	0xBE	/* Alt =	*/

#define ALTA 0xC1
#define ALTB 0xC2
#define ALTC 0xC3
#define ALTD 0xC4
#define ALTE 0xC5
#define ALTF 0xC6
#define ALTG 0xC7
#define ALTH 0xC8
#define ALTI 0xC9
#define ALTJ 0xCA
#define ALTK 0xCB
#define ALTL 0xCC
#define ALTM 0xCD
#define ALTN 0xCE
#define ALTO 0xCF
#define ALTP 0xD0
#define ALTQ 0xD1
#define ALTR 0xD2
#define ALTS 0xD3
#define ALTT 0xD4
#define ALTU 0xD5
#define ALTV 0xD6
#define ALTW 0xD7
#define ALTX 0xD8
#define ALTY 0xD9
#define ALTZ 0xDA
#define THENUL 0xDB

#else
      				/* new keyboard definitions */
#define F1   0x13b
#define F2   0x13c
#define F3   0x13d
#define F4   0x13e
#define F5   0x13f
#define F6   0x140
#define F7   0x141
#define F8   0x142
#define F9   0x143
#define F10  0x144
#define F11  0xea
#define F12  0xeb

#define SF1  0x354
#define SF2  0x355
#define SF3  0x356
#define SF4  0x357
#define SF5  0x358
#define SF6  0x359
#define SF7  0x35a
#define SF8  0x35b
#define SF9  0x35c
#define SF10 0x35c
#define SF11 0xec
#define SF12 0xed

#define CF1  0x55e
#define CF2  0x55f
#define CF3  0x560
#define CF4  0x561
#define CF5  0x562
#define CF6  0x563
#define CF7  0x564
#define CF8  0x565
#define CF9  0x566
#define CF10 0x567
#define CF11 0xef
#define CF12 0xf0

#define ALT1 0x978
#define ALT2 0x979
#define ALT3 0x97a
#define ALT4 0x97b
#define ALT5 0x97c
#define ALT6 0x97d
#define ALT7 0x97e
#define ALT8 0x97f
#define ALT9 0x980
#define ALT0 0x981

#define AF1  0x968
#define AF2  0x969
#define AF3  0x96a
#define AF4  0x96b
#define AF5  0x96c
#define AF6  0x96d
#define AF7  0x96e
#define AF8  0x96f
#define AF9  0x970
#define AF10 0x971
#define AF11 0xf1
#define AF12 0xf2
	/* oops, these are w/o numlock being on , add 0x200 for numlock */

#define HOME		0x147	/* HOME key	*/
#define CURLF		0x14b	/* <-		*/
#define ENDKEY		0x14f	/* END key	*/
#define CURUP		0x148	/* up arrow	*/
#define CURDN		0x150	/* down arrow	*/
#define PGUP		0x149	/* PgUp		*/
#define CURRT		0x14d	/* ->		*/
#define PGDN		0x151	/* PgDn		*/
#define INSERT		0x152	/* Ins		*/
#define DELETE		0x153	/* Del		*/
#define BACKSPACE	0x10e


#define CTRLHOME	0x577	/* Ctrl Home	*/
#define CTRLCURLF	0x573	/* Ctrl <-	*/
#define CTRLEND	0x575	/* Ctrl End	*/
#define CTRLPRTSC	0x772	/* Ctrl PrtSc	*/
#define CTRLPGUP	0x584	/* Ctrl PgUp	*/
#define CTRLCURRT	0x574	/* Ctrl ->	*/
#define CTRLPGDN	0x576	/* Ctrl PgDn	*/
#define REVTAB		0x30f	/* Shift Tab	*/
#define ALTMINUS	0x982	/* Alt -	*/

#define ALTEQUAL	0x983	/* Alt =	*/

#define ALTA 0x91e
#define ALTB 0x930
#define ALTC 0x92e
#define ALTD 0x920
#define ALTE 0x912
#define ALTF 0x921
#define ALTG 0x922
#define ALTH 0x923
#define ALTI 0x917
#define ALTJ 0x924
#define ALTK 0x925
#define ALTL 0x926
#define ALTM 0x932
#define ALTN 0x931
#define ALTO 0x918
#define ALTP 0x919
#define ALTQ 0x910
#define ALTR 0x913
#define ALTS 0x91f
#define ALTT 0x914
#define ALTU 0x916
#define ALTV 0x92f
#define ALTW 0x911
#define ALTX 0x92d
#define ALTY 0x915
#define ALTZ 0x92c
#define THENUL 0
#endif
